/* Alternate bit protocol */

chan c = [10] of {bool};
chan d = [10] of {bool};

chan f = [0] of {bool};
chan e = [0] of {bool};

active proctype Sender() {
bool y = false; /* current value of the bit, initially 0 */
bool ack; /* variable to receive the acknowledgment bit */

message:
do
  :: skip; /* message is produced */
     try_to_send:
     if
       :: c!y; /* message is really sent */ 
       :: /* message is lost! */ skip
     fi;
     e!true; /* activate the timer */
     wait: 
     if
       :: /* timeout */ f?_; goto try_to_send
       :: /* reception of an acknoledgment */ d?ack; 
             /* check the ack bit */
             if
               :: (ack == y) -> /* deactivate the timer */ 
                                e!true; 
                                /* change the current value of the bit */
                                y = !y;
                                /* go back to the initial state for another message */
                                goto message
               :: (ack != y) -> goto wait
             fi
     fi
od

}

active proctype Receiver() {
bool y = false; /* current value of the bit, initially 0 */
bool b; /* variable to receive the bit associated to the message, which is emtpy */

do
  :: /* receive the message and the bit, actually only the bit */ c?b;
     /* check the bit */
     if
       :: (b == y) -> /* send the acknoledgement */
                      d!y;
                      /* change the value of the bit */
                      y = !y;
                      /* go back */
       :: (b != y) -> /* go back */
     fi
od
}

active proctype Timer() {
do
  :: e?_ ->  
           on: /* timer is on */
               if
                  :: e?_ /* timer is reset by the Sender */
                  :: f!true /* timer signals timeout and reset */
               fi 

od
}

